#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire2600five4xi.py">
#<abstract4xi abstract = "fires to direction five and to distance 2600"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2five4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
# -------------------------------------------------------------------------------------------------
# SHOT2FIVE - COORDINATE SIGNS OF SHOOT2FIVE4XI: (X - ,Y + ,Z + )
# -------------------------------------------------------------------------------------------------    
global shot2five26004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

shot2five26004xi = {
                1: '-1034x2241y816z',
                2: '-1040x605y2304z',
                3: '-1048x1614y1747z',
                4: '-1084x1454y1861z',
                5: '-1091x560y2292z',
                6: '-109x17y2597z',
                7: '-1140x512y2279z',
                8: '-1141x1571y1728z',
                9: '-1154x2191y791z',
                10: '-1171x1410y1843z',
                11: '-1186x459y2267z',
                12: '-122x787y2474z',
                13: '-1230x404y2254z',
                14: '-1233x1522y1708z',
                15: '-1255x1360y1825z',
                16: '-1271x2134y766z',
                17: '-1271x345y2241z',
                18: '-1309x282y2228z',
                19: '-1322x1468y1689z',
                20: '-1338x1305y1806z',
                21: '-1344x217y2214z',
                22: '-135x14y2596z',
                23: '-1376x149y2200z',
                24: '-1385x2071y741z',
                25: '-1404x78y2186z',
                26: '-1409x1409y1669z',
                27: '-1418x1245y1787z',
                28: '-1428x4y2172z',
                29: '-1493x1344y1649z',
                30: '-1495x1180y1768z',
                31: '-1496x2001y716z',
                32: '-1569x1111y1749z',
                33: '-1574x1275y1629z',
                34: '-1603x1926y691z',
                35: '-162x9y2594z',
                36: '-1640x1036y1730z',
                37: '-1652x1200y1608z',
                38: '-168x804y2466z',
                39: '-1706x1844y666z',
                40: '-1707x957y1711z',
                41: '-1726x1121y1588z',
                42: '-1770x874y1691z',
                43: '-1796x1037y1567z',
                44: '-1805x1757y641z',
                45: '-1829x787y1671z',
                46: '-183x1750y1913z',
                47: '-1862x948y1546z',
                48: '-1883x696y1651z',
                49: '-188x0y2593z',
                50: '-1899x1664y616z',
                51: '-1923x856y1525z',
                52: '-1933x601y1631z',
                53: '-1977x503y1611z',
                54: '-1979x759y1504z',
                55: '-1989x1566y591z',
                56: '-2016x402y1590z',
                57: '-2030x659y1483z',
                58: '-2050x298y1569z',
                59: '-2073x1463y565z',
                60: '-2076x556y1462z',
                61: '-2079x192y1549z',
                62: '-2117x450y1440z',
                63: '-2151x1356y540z',
                64: '-2151x340y1418z',
                65: '-216x818y2458z',
                66: '-2180x229y1396z',
                67: '-2182x87y1586z',
                68: '-2203x115y1374z',
                69: '-2220x0y1352z',
                70: '-2224x1244y514z',
                71: '-2290x1128y489z',
                72: '-2351x1008y463z',
                73: '-2404x885y438z',
                74: '-2451x760y412z',
                75: '-2492x631y386z',
                76: '-2525x501y361z',
                77: '-2551x368y335z',
                78: '-2570x235y309z',
                79: '-2582x100y283z',
                80: '-266x828y2449z',
                81: '-276x1616y2017z',
                82: '-278x1757y1896z',
                83: '-284x2398y962z',
                84: '-30x10y2599z',
                85: '-318x836y2441z',
                86: '-365x1619y2001z',
                87: '-371x841y2431z',
                88: '-373x1758y1878z',
                89: '-411x2389y938z',
                90: '-425x842y2422z',
                91: '-454x1617y1984z',
                92: '-470x1754y1860z',
                93: '-481x839y2413z',
                94: '-537x833y2403z',
                95: '-538x2373y914z',
                96: '-545x1609y1967z',
                97: '-567x1745y1841z',
                98: '-56x15y2599z',
                99: '-594x823y2393z',
                100: '-635x1597y1950z',
                101: '-651x810y2382z',
                102: '-664x1730y1823z',
                103: '-664x2350y889z',
                104: '-6x2y2599z',
                105: '-709x792y2372z',
                106: '-726x1579y1933z',
                107: '-761x1709y1804z',
                108: '-766x771y2361z',
                109: '-789x2321y865z',
                110: '-78x768y2482z',
                111: '-817x1556y1915z',
                112: '-823x745y2350z',
                113: '-82x17y2598z',
                114: '-857x1683y1785z',
                115: '-879x716y2339z',
                116: '-907x1527y1897z',
                117: '-912x2284y840z',
                118: '-934x683y2328z',
                119: '-953x1651y1766z',
                120: '-988x646y2316z',
                121: '-996x1494y1880z'}
#"
#"/>

# ----------------------------------------------------------------------------------------------------------------
#<function4xi function = "fire2600five4xi" usage = "target function for charge26004xi4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# ----------------------------------------------------------------------------------------------------------------
def fire2600five4xi(queue2five, consumer_channel2five, publisher_channel2five):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE2600FIVE4XIFIVE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE2600FIVE4XIFIVE4XI -  QUEUE2FIVE: ", queue2five)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE2600FIVE4XIFIVE4XI -  CONSUMER_CHANNEL2FIVE: ", consumer_channel2five)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE2600FIVE4XIFIVE4XI -  PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE2600FIVE4XIFIVE4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2five.put(shot2five26004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE2600FIVE4XIFIVE4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE2600FIVE4XIFIVE4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE2600FIVE4XIFIVE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2five8shot2five26004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2five8shot2five26004xi</nack2put4xi>" 
            
        publisher_channel2five.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE2600FIVE4XIFIVE4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE2600FIVE4XIFIVE4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE2600FIVE4XIFIVE4XI - RETURNING QUEUE OBJECT QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi())  
        # 
            
    return queue2five    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire2600five4xi.py                             
# -------------------------------------------------------------------------------------------------                